<template>
<div class="col-md-3 col-sm-6 col-xs-12" v-show="true">

    <article :id="'material-card-'+$vnode.key" class="material-card Yellow">
        <h2>
          <span class="truncate"> <em>{{ entity.civilite | ucFirst}}</em> {{ entity.prenom | ucFirst}} {{ entity.nom | ucFirst}}</span>
            <strong class="truncate">
             <i class="las la-industry"></i>
                        {{ entity ? (entity.secteur ?  entity.secteur.libelle : 'Non précisé' ) : 'Non précisé' | ucFirst }} 
           </strong>
           <strong class="truncate">
             <i class="fas fa-fw fa-award"></i>
                        Promotion : {{ entity.promotion | ucFirst}} 
           </strong>

        </h2>
        <div class="mc-content">

            <div class="img-container">
                <a href="javascript:void(0)" @click.prevent="seeMember" style="width:inherit">
                     <img :src=" !entity.hasPhoto ? '/img/default_member.png' : '/storage/featured/'+entity.avatar" class="img-responsive">
                </a>

               <img :src=" entity.residence ? '/storage/flags/'+entity.residence.flagPath : '/storage/flags/unknown.png'" alt="" class="src nationalite-flag" title="Pays de résidence">
            </div>

            <div class="mc-description">
               {{ entity.description | ucFirst}}         
            </div>
            <div class="mc-ud"> 
                <button v-if="false" type="button" title="Voir le membre" class="btn" @click="seeMember">
                        <i class="fas  fa-eye"></i>
                </button>
                <button type="button" title="Modifier le membre" class="btn" @click="updateMember">
                        <i class="fas  fa-edit"></i>
                </button>
                <button type="button" title="Supprimer le membre" class="btn" @click="deleteMember">
                        <i class="fas  fa-trash"></i>
                </button>
            </div>

        </div> 
        <a class="mc-btn-action"><i class="fa fa-bars"></i></a>
        <div class="mc-footer">
            <h4>
                Résaux sociaux
            </h4> 
            <a :href=" entity.facebook ? entity.facebook : 'https://www.facebook.com/' "  target="_blank" class="text-center"><i class="fab fa-facebook"></i></a> 
            <a  :href=" entity.twitter ? entity.twitter : 'https://www.twitter.com/' "  target="_blank"  class=""><i class="fab  fa-twitter"></i></a> 
            <a :href=" entity.linkedin ? entity.linkedin : 'https://www.linkedin.com/' "  target="_blank"  class=""><i class="fab fa-linkedin-in"></i></a></div>
    </article>

</div>
</template>
<script>
    export default {
        props: ['entity','isSet'],       
         data() {
            return{
                
                vehicule_est_connu:false,
                visible:false,

                vehicule:{
                    libelle: "Wills",
                    marque_id: 5,
                    modele_id: 51,
                    type_vehicule_id: 1,
                    type_permis_id: null,
                    nbr_place: 5,
                    nbr_porte: 5,
                    couleur: "Rouge",
                    image_mise_en_avant: "22-5e6296894e7be.jpeg",
                    tarif: 50000,
                    kilometrage: 23554,
                    plaque_immatriculation: "AZSE-RTDFD-ddd",
                    nr_chassis: "ERDF-ERFFF-FR",
                    date_mise_en_circulation: "2016-02-05",
                    annee_mise_en_circulation: "0000-02-05 00:00:00",
                    consommation_au_100_km: 5.5,
                    type_motorisation_id: 13,
                    boite_vitesse: "automatique",
                    volume_coffre: 100,
                    volume_reservoir: 60,
                    largeur: 2.4,
                    longueur: null,
                    poids: 1290,
                    hauteur: null,
                    created_at: "2020-03-06 18:29:29",
                    updated_at: "2020-03-06 18:29:29",
                    path: "/storage/images/",
                    marque : {},
                    modele : {},
                    marque: {},
                    title: "",
                    modele: {},
                    type_motorisation: {},
                    type_vehicule: {}
                }
            }
            
        },
        mounted() {
          var vm = this
           $('#material-card-'+this.$vnode.key+' .img-responsive').on('load', function () {
                
                vm.visible = true

            });
   $('#material-card-'+this.$vnode.key+' > .mc-btn-action').click(function ()
    {
            var card = $(this).parent('.material-card');
            var icon = $(this).children('i');
            var flag = $('#material-card-'+vm.$vnode.key).find('.nationalite-flag');
            icon.addClass('fa-spin-fast');

            if (card.hasClass('mc-active')) {
                card.removeClass('mc-active');
                        flag.removeClass('z-index--1')

                window.setTimeout(function() {
                    icon
                        .removeClass('fa-arrow-left')
                        .removeClass('fa-spin-fast')
                        .addClass('fa-bars');

                }, 800);
            } else {
                card.addClass('mc-active');
                flag.addClass('z-index--1')
                window.setTimeout(function() {
                    icon
                        .removeClass('fa-bars')
                        .removeClass('fa-spin-fast')
                        .addClass('fa-arrow-left');
                        

                }, 800);
            }
        });
        },
        computed:
        {
            nationalite()
            {
                if(isDefined(this.entity))
                {
                    if(this.entity.nationalites.length> 0)
                      return this.entity.nationalites[0]
                    else
                      return null
                }
                return null
            }
        },
        methods:
        {
             deleteMember()
             {
 
                 
                  
                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer ce membre ?","Suppréssion d'un membre")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                               this.$store.dispatch('members/removeMember',this.entity).then((response) =>
                                {
                                        this.isLoading = false
                                        flash("<span>Supprimé <strong>avec succès</strong></span>",'success')
                                        this.initForm()
                                },
                                (error) => 
                                {
                                    this.isLoading = false
                                })
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
             },
             updateMember()
             {
                 window.event.$emit('update-member-event',{entity:this.entity,key:this.$vnode.key})
             },
             seeMember()
             {
                 window.event.$emit('see-member-event',{entity:this.entity,key:this.$vnode.key})
             }
        }
    }
</script>
<style lang="scss" scoped>

.nationalite-flag
{
position: absolute;
    width: 29px !important;
    height: 20px;
    border-radius: 3px !important;
    left: 10px;
    top: 21px;
}
.z-index--1
{
  opacity:0;
    -webkit-transition: all 0.1s;
  -moz-transition: all 0.1s;
  -ms-transition: all 0.1s;
  -o-transition: all 0.1s;
  transition: all 0.1s;
}
</style>